package com.zhilian.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zhilian.common.business.domain.Markers;
import com.zhilian.common.business.domain.middle.MarkersFence;
import com.zhilian.business.mapper.MarkersFenceMapper;
import com.zhilian.business.service.MarkersFenceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class MarkersFenceServiceImpl extends ServiceImpl<MarkersFenceMapper, MarkersFence> implements MarkersFenceService  {
    @Autowired
    private MarkersFenceMapper markersFenceMapper;


    @Override
    public boolean insert(Markers markers) {
        markers.getFenceIds().forEach(fenceId -> {
            MarkersFence markersFence = new MarkersFence();
            markersFence.setMarkerId(markers.getMarkersId());
            markersFence.setFenceId(fenceId);
            markersFenceMapper.insert(markersFence);
        });
        return true;
    }

    @Override
    public void removeAllFence(Markers markers) {
        List<MarkersFence> list = this.list(new LambdaQueryWrapper<MarkersFence>().eq(MarkersFence::getMarkerId, markers.getMarkersId()));
        list.forEach(item -> {
            this.removeById(item.getMarkerId());
        });
    }
}
